export declare type Email = string;
export declare type Currency = number | {
    amount?: number;
    currency?: 'USD' | 'EUR' | 'AUD' | 'CAD' | 'CHF' | 'CNY' | 'GBP' | 'INR' | 'JPY';
    symbol?: '$' | '€' | '£' | '¥';
};
export declare type Percentage = number;
export declare type KeyValue<T = any> = {
    [key: string]: T;
};
export declare type Markdown = string;
export declare type KPI = boolean | number | Percentage | Currency;
export declare type Domain = string | string[] | {
    name: string;
    tld: string;
};
export declare type Subdomain = string | string[] | {
    name: string;
    domain: Domain | Subdomain;
};
export declare type HttpMethod = 'https' | 'http';
